diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac-queue.cc ns-3.36/src/wifi/model/wifi-mac-queue.cc
--- ns-3.35/src/wifi/model/wifi-mac-queue.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac-queue.cc	2022-04-30 18:23:58.214735300 -0700
@@ -75,9 +75,27 @@
   m_nQueuedBytes.clear ();
 }
 
-static std::list<Ptr<WifiMacQueueItem>> g_emptyWifiMacQueue; //!< empty Wi-Fi MAC queue
+bool
+WifiMacQueue::TtlExceeded (ConstIterator &it, const Time& now)
+{
+  if (now > (*it)->GetTimeStamp () + m_maxDelay)
+    {
+      NS_LOG_DEBUG ("Removing packet that stayed in the queue for too long (" <<
+                    now - (*it)->GetTimeStamp () << ")");
+      auto curr = it++;
+      m_traceExpired (DoRemove (curr));
+      return true;
+    }
+  return false;
+}
 
-const WifiMacQueue::ConstIterator WifiMacQueue::EMPTY = g_emptyWifiMacQueue.end ();
+bool
+WifiMacQueue::TtlExceeded (Ptr<const WifiMacQueueItem> item, const Time& now)
+{
+  NS_ASSERT (item != nullptr && item->IsQueued ());
+  auto it = item->m_queueIt;
+  return TtlExceeded (it, now);
+}
 
 void
 WifiMacQueue::SetMaxDelay (Time delay)
@@ -204,11 +222,13 @@
   return 0;
 }
 
-WifiMacQueue::ConstIterator
-WifiMacQueue::PeekByAddress (Mac48Address dest, ConstIterator pos) const
+Ptr<const WifiMacQueueItem>
+WifiMacQueue::PeekByAddress (Mac48Address dest, Ptr<const WifiMacQueueItem> item) const
 {
-  NS_LOG_FUNCTION (this << dest);
-  ConstIterator it = (pos != EMPTY ? pos : begin ());
+  NS_LOG_FUNCTION (this << dest << item);
+  NS_ASSERT (item == nullptr || item->IsQueued ());
+
+  ConstIterator it = (item != nullptr ? std::next (item->m_queueIt) : begin ());
   const Time now = Simulator::Now ();
   while (it != end ())
     {
@@ -219,20 +239,22 @@
           if (((*it)->GetHeader ().IsData () || (*it)->GetHeader ().IsQosData ())
               && (*it)->GetDestinationAddress () == dest)
             {
-              return it;
+              return *it;
             }
         }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
-  return end ();
+  return nullptr;
 }
 
-WifiMacQueue::ConstIterator
-WifiMacQueue::PeekByTid (uint8_t tid, ConstIterator pos) const
+Ptr<const WifiMacQueueItem>
+WifiMacQueue::PeekByTid (uint8_t tid, Ptr<const WifiMacQueueItem> item) const
 {
-  NS_LOG_FUNCTION (this << +tid);
-  ConstIterator it = (pos != EMPTY ? pos : begin ());
+  NS_LOG_FUNCTION (this << +tid << item);
+  NS_ASSERT (item == nullptr || item->IsQueued ());
+
+  ConstIterator it = (item != nullptr ? std::next (item->m_queueIt) : begin ());
   const Time now = Simulator::Now ();
   while (it != end ())
     {
@@ -242,20 +264,22 @@
         {
           if ((*it)->GetHeader ().IsQosData () && (*it)->GetHeader ().GetQosTid () == tid)
             {
-              return it;
+              return *it;
             }
         }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
-  return end ();
+  return nullptr;
 }
 
-WifiMacQueue::ConstIterator
-WifiMacQueue::PeekByTidAndAddress (uint8_t tid, Mac48Address dest, ConstIterator pos) const
+Ptr<const WifiMacQueueItem>
+WifiMacQueue::PeekByTidAndAddress (uint8_t tid, Mac48Address dest, Ptr<const WifiMacQueueItem> item) const
 {
-  NS_LOG_FUNCTION (this << +tid << dest);
-  ConstIterator it = (pos != EMPTY ? pos : begin ());
+  NS_LOG_FUNCTION (this << +tid << dest << item);
+  NS_ASSERT (item == nullptr || item->IsQueued ());
+
+  ConstIterator it = (item != nullptr ? std::next (item->m_queueIt) : begin ());
   const Time now = Simulator::Now ();
   while (it != end ())
     {
@@ -266,20 +290,23 @@
           if ((*it)->GetHeader ().IsQosData () && (*it)->GetDestinationAddress () == dest
               && (*it)->GetHeader ().GetQosTid () == tid)
             {
-              return it;
+              return *it;
             }
         }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
-  return end ();
+  return nullptr;
 }
 
-WifiMacQueue::ConstIterator
-WifiMacQueue::PeekFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets, ConstIterator pos) const
+Ptr<const WifiMacQueueItem>
+WifiMacQueue::PeekFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets,
+                                  Ptr<const WifiMacQueueItem> item) const
 {
-  NS_LOG_FUNCTION (this);
-  ConstIterator it = (pos != EMPTY ? pos : begin ());
+  NS_LOG_FUNCTION (this << item);
+  NS_ASSERT (item == nullptr || item->IsQueued ());
+
+  ConstIterator it = (item != nullptr ? std::next (item->m_queueIt) : begin ());
   const Time now = Simulator::Now ();
   while (it != end ())
     {
@@ -290,13 +317,13 @@
           if (!(*it)->GetHeader ().IsQosData () || !blockedPackets
               || !blockedPackets->IsBlocked ((*it)->GetHeader ().GetAddr1 (), (*it)->GetHeader ().GetQosTid ()))
             {
-              return it;
+              return *it;
             }
         }
       it++;
     }
   NS_LOG_DEBUG ("The queue is empty");
-  return end ();
+  return nullptr;
 }
 
 Ptr<WifiMacQueueItem>
@@ -316,39 +343,17 @@
   return 0;
 }
 
-bool
-WifiMacQueue::Remove (Ptr<const Packet> packet)
-{
-  NS_LOG_FUNCTION (this << packet);
-
-  const Time now = Simulator::Now ();
-  for (ConstIterator it = begin (); it != end (); )
-    {
-      if (!TtlExceeded (it, now))
-        {
-          if ((*it)->GetPacket () == packet)
-            {
-              DoRemove (it);
-              return true;
-            }
-
-          it++;
-        }
-    }
-  NS_LOG_DEBUG ("Packet " << packet << " not found in the queue");
-  return false;
-}
-
-WifiMacQueue::ConstIterator
-WifiMacQueue::Remove (ConstIterator pos, bool removeExpired)
+Ptr<const WifiMacQueueItem>
+WifiMacQueue::Remove (Ptr<const WifiMacQueueItem> item, bool removeExpired)
 {
-  NS_LOG_FUNCTION (this);
+  NS_LOG_FUNCTION (this << item << removeExpired);
+  NS_ASSERT (item != 0 && item->IsQueued ());
 
   if (!removeExpired)
     {
-      ConstIterator curr = pos++;
-      DoRemove (curr);
-      return pos;
+      ConstIterator next = std::next (item->m_queueIt);
+      DoRemove (item->m_queueIt);
+      return (next == end () ? nullptr : *next);
     }
 
   const Time now = Simulator::Now ();
@@ -357,11 +362,11 @@
   ConstIterator it = begin ();
   while (it != end ())
     {
-      if (it == pos)
+      if (*it == item)
         {
-          ConstIterator curr = pos++;
-          DoRemove (curr);
-          return pos;
+          ConstIterator next = std::next (item->m_queueIt);
+          DoRemove (item->m_queueIt);
+          return (next == end () ? nullptr : *next);
         }
       else if (!TtlExceeded (it, now))
         {
@@ -369,7 +374,24 @@
         }
     }
   NS_LOG_DEBUG ("Invalid iterator");
-  return end ();
+  return nullptr;
+}
+
+void
+WifiMacQueue::Replace (Ptr<const WifiMacQueueItem> currentItem, Ptr<WifiMacQueueItem> newItem)
+{
+  NS_LOG_FUNCTION (this << *currentItem << *newItem);
+  NS_ASSERT (currentItem->IsQueued ());
+  NS_ASSERT (currentItem->m_queueAc == m_ac);
+  NS_ASSERT (*currentItem->m_queueIt == currentItem);
+  NS_ASSERT (!newItem->IsQueued ());
+
+  auto pos = std::next (currentItem->m_queueIt);
+  DoDequeue (currentItem->m_queueIt);
+  bool ret = Insert (pos, newItem);
+  // The size of a WifiMacQueue is measured as number of packets. We dequeued
+  // one packet, so there is certainly room for inserting one packet
+  NS_ABORT_IF (!ret);
 }
 
 uint32_t
@@ -528,12 +550,6 @@
 {
   NS_LOG_FUNCTION (this);
 
-  if (TtlExceeded (pos, Simulator::Now ()))
-    {
-      NS_LOG_DEBUG ("Packet lifetime expired");
-      return nullptr;
-    }
-
   Ptr<WifiMacQueueItem> item = Queue<WifiMacQueueItem>::DoDequeue (pos);
 
   if (item != 0 && item->GetHeader ().IsQosData ())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac-queue.h ns-3.36/src/wifi/model/wifi-mac-queue.h
--- ns-3.35/src/wifi/model/wifi-mac-queue.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac-queue.h	2022-04-30 18:23:58.214735300 -0700
@@ -28,6 +28,7 @@
 #include "ns3/queue.h"
 #include <unordered_map>
 #include "qos-utils.h"
+#include <functional>
 
 namespace ns3 {
 
@@ -115,14 +116,6 @@
    */
   bool PushFront (Ptr<WifiMacQueueItem> item);
   /**
-   * Enqueue the given Wifi MAC queue item before the given position.
-   *
-   * \param pos the position before which the item is to be inserted
-   * \param item the Wifi MAC queue item to be enqueued
-   * \return true if success, false if the packet has been dropped
-   */
-  bool Insert (ConstIterator pos, Ptr<WifiMacQueueItem> item);
-  /**
    * Dequeue the packet in the front of the queue.
    *
    * \return the packet
@@ -143,53 +136,61 @@
   /**
    * Search and return, if present in the queue, the first packet (either Data
    * frame or QoS Data frame) having the receiver address equal to <i>addr</i>.
-   * If <i>pos</i> is a valid iterator, the search starts from the packet pointed
-   * to by the given iterator.
+   * If <i>item</i> is not a null pointer, the search starts from the packet following
+   * <i>item</i> in the queue; otherwise, the search starts from the head of the queue.
    * This method does not remove the packet from the queue.
    *
    * \param dest the given destination
-   * \param pos the iterator pointing to the packet the search starts from
+   * \param item the item after which the search starts from
    *
-   * \return an iterator pointing to the peeked packet
+   * \return the peeked packet or nullptr if no packet was found
    */
-  ConstIterator PeekByAddress (Mac48Address dest, ConstIterator pos = EMPTY) const;
+  Ptr<const WifiMacQueueItem> PeekByAddress (Mac48Address dest,
+                                             Ptr<const WifiMacQueueItem> item = nullptr) const;
   /**
    * Search and return, if present in the queue, the first packet having the
-   * TID equal to <i>tid</i>. If <i>pos</i> is a valid iterator, the search starts
-   * from the packet pointed to by the given iterator.
+   * TID equal to <i>tid</i>. If <i>item</i> is not a null pointer, the search
+   * starts from the packet following <i>item</i> in the queue; otherwise, the
+   * search starts from the head of the queue.
    * This method does not remove the packet from the queue.
    *
    * \param tid the given TID
-   * \param pos the iterator pointing to the packet the search starts from
+   * \param item the item after which the search starts from
    *
-   * \return an iterator pointing to the peeked packet
+   * \return the peeked packet or nullptr if no packet was found
    */
-  ConstIterator PeekByTid (uint8_t tid, ConstIterator pos = EMPTY) const;
+  Ptr<const WifiMacQueueItem> PeekByTid (uint8_t tid,
+                                         Ptr<const WifiMacQueueItem> item = nullptr) const;
   /**
    * Search and return, if present in the queue, the first packet having the
    * receiver address equal to <i>dest</i>, and TID equal to <i>tid</i>.
-   * If <i>pos</i> is a valid iterator, the search starts from the packet pointed
-   * to by the given iterator. This method does not remove the packet from the queue.
+   * If <i>item</i> is not a null pointer, the search starts from the packet
+   * following <i>item</i> in the queue; otherwise, the search starts from the
+   * head of the queue. This method does not remove the packet from the queue.
    * It is typically used by ns3::QosTxop in order to perform correct MSDU aggregation
    * (A-MSDU).
    *
    * \param tid the given TID
    * \param dest the given destination
-   * \param pos the iterator pointing to the packet the search starts from
+   * \param item the item after which the search starts from
    *
-   * \return an iterator pointing to the peeked packet
+   * \return the peeked packet or nullptr if no packet was found
    */
-  ConstIterator PeekByTidAndAddress (uint8_t tid, Mac48Address dest, ConstIterator pos = EMPTY) const;
+  Ptr<const WifiMacQueueItem> PeekByTidAndAddress (uint8_t tid, Mac48Address dest,
+                                                   Ptr<const WifiMacQueueItem> item = nullptr) const;
   /**
-   * Return first available packet for transmission. The packet is not removed from queue.
+   * Return first available packet for transmission. If <i>item</i> is not a null
+   * pointer, the search starts from the packet following <i>item</i> in the queue;
+   * otherwise, the search starts from the head of the queue.
+   * The packet is not removed from queue.
    *
    * \param blockedPackets the destination address & TID pairs that are waiting for a BlockAck response
-   * \param pos the iterator pointing to the packet the search starts from
+   * \param item the item after which the search starts from
    *
-   * \return an iterator pointing to the peeked packet
+   * \return the peeked packet or nullptr if no packet was found
    */
-  ConstIterator PeekFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets = nullptr,
-                                    ConstIterator pos = EMPTY) const;
+  Ptr<const WifiMacQueueItem> PeekFirstAvailable (const Ptr<QosBlockedDestinations> blockedPackets = nullptr,
+                                                  Ptr<const WifiMacQueueItem> item = nullptr) const;
   /**
    * Remove the packet in the front of the queue.
    *
@@ -197,26 +198,53 @@
    */
   Ptr<WifiMacQueueItem> Remove (void) override;
   /**
-   * If exists, removes <i>packet</i> from queue and returns true. Otherwise it
-   * takes no effects and return false. Deletion of the packet is
-   * performed in linear time (O(n)).
+   * Remove the given item from the queue and return the item following the
+   * removed one, if any, or a null pointer otherwise. If <i>removeExpired</i> is
+   * true, all the items in the queue from the head to the given position are
+   * removed if their lifetime expired.
    *
-   * \param packet the packet to be removed
+   * \param item the item to be removed
+   * \param removeExpired true to remove expired items
+   * \return the item following the removed one, if any, or a null pointer, otherwise
+   */
+  Ptr<const WifiMacQueueItem> Remove (Ptr<const WifiMacQueueItem> item, bool removeExpired = false);
+
+  /**
+   * Replace the given current item with the given new item. Actually, the current
+   * item is dequeued and the new item is enqueued in its place. In this way,
+   * statistics about queue size (in terms of bytes) are correctly updated.
    *
-   * \return true if the packet was removed, false otherwise
+   * \param currentItem the given current item
+   * \param newItem the given new item
    */
-  bool Remove (Ptr<const Packet> packet);
+  void Replace (Ptr<const WifiMacQueueItem> currentItem, Ptr<WifiMacQueueItem> newItem);
   /**
-   * Remove the item at position <i>pos</i> in the queue and return an iterator
-   * pointing to the item following the removed one. If <i>removeExpired</i> is
-   * true, all the items in the queue from the head to the given position are
-   * removed if their lifetime expired.
+   * Transform the given item by invoking the given function with the given item
+   * as parameter. The given function must be an object of a callable type
+   * and must have an argument of type pointer to WifiMacQueueItem.
+   * Actually, the given item is dequeued and the transformed item is enqueued in
+   * its place. In this way, statistics about queue size (in terms of bytes) are
+   * correctly updated.
    *
-   * \param pos the position of the item to be removed
-   * \param removeExpired true to remove expired items
-   * \return an iterator pointing to the item following the removed one
+   * \internal
+   * If this method needs to be overloaded, we can use SFINAE to help in overload
+   * resolution:
+   *
+   * \code
+   *   template <class CALLABLE,
+   *             std::invoke_result_t<CALLABLE, Ptr<WifiMacQueueItem>>* = nullptr>
+   *   void Transform (Ptr<const WifiMacQueueItem> item, CALLABLE func);
+   * \endcode
+   *
+   * Unfortunately, this will break python bindings scanning.
+   *
+   * \tparam CALLABLE \deduced The type of the given function object
+   * \param item the given item
+   * \param func the given function object
    */
-  ConstIterator Remove (ConstIterator pos, bool removeExpired = false);
+  template <class CALLABLE>
+  void Transform (Ptr<const WifiMacQueueItem> item, CALLABLE func);
+
   /**
    * Return the number of packets having destination address specified by
    * <i>dest</i>. The complexity is linear in the size of the queue.
@@ -285,6 +313,17 @@
   uint32_t GetNBytes (void);
 
   /**
+   * Remove the given item if it has been in the queue for too long. Return true
+   * if the item is removed, false otherwise.
+   *
+   * \param item the item whose lifetime is checked
+   * \param now a copy of Simulator::Now()
+   * \return true if the item is removed, false otherwise
+   */
+  bool TtlExceeded (Ptr<const WifiMacQueueItem> item, const Time& now);
+
+private:
+  /**
    * Remove the item pointed to by the iterator <i>it</i> if it has been in the
    * queue for too long. If the item is removed, the iterator is updated to
    * point to the item that followed the erased one.
@@ -295,10 +334,14 @@
    */
   inline bool TtlExceeded (ConstIterator &it, const Time& now);
 
-  static const ConstIterator EMPTY;         //!< Invalid iterator to signal an empty queue
-
-
-private:
+  /**
+   * Enqueue the given Wifi MAC queue item before the given position.
+   *
+   * \param pos the position before which the item is to be inserted
+   * \param item the Wifi MAC queue item to be enqueued
+   * \return true if success, false if the packet has been dropped
+   */
+  bool Insert (ConstIterator pos, Ptr<WifiMacQueueItem> item);
   /**
    * Wrapper for the DoEnqueue method provided by the base class that additionally
    * sets the iterator field of the item and updates internal statistics, if
@@ -343,23 +386,31 @@
   NS_LOG_TEMPLATE_DECLARE;                  //!< redefinition of the log component
 };
 
+} // namespace ns3
 
-/**
- * Implementation of inline functions
- */
 
-bool
-WifiMacQueue::TtlExceeded (ConstIterator &it, const Time& now)
+/***************************************************************
+ *  Implementation of the templates declared above.
+ ***************************************************************/
+
+namespace ns3 {
+
+template <class CALLABLE>
+void
+WifiMacQueue::Transform (Ptr<const WifiMacQueueItem> item, CALLABLE func)
 {
-  if (now > (*it)->GetTimeStamp () + m_maxDelay)
-    {
-      NS_LOG_DEBUG ("Removing packet that stayed in the queue for too long (" <<
-                    now - (*it)->GetTimeStamp () << ")");
-      auto curr = it++;
-      m_traceExpired (DoRemove (curr));
-      return true;
-    }
-  return false;
+  NS_ASSERT (item->IsQueued ());
+  NS_ASSERT (item->m_queueAc == m_ac);
+  NS_ASSERT (*item->m_queueIt == item);
+
+  auto pos = std::next (item->m_queueIt);
+  Ptr<WifiMacQueueItem> mpdu = DoDequeue (item->m_queueIt);
+  NS_ASSERT (mpdu != nullptr);
+  func (mpdu);     // python bindings scanning does not like std::invoke (func, mpdu);
+  bool ret = Insert (pos, mpdu);
+  // The size of a WifiMacQueue is measured as number of packets. We dequeued
+  // one packet, so there is certainly room for inserting one packet
+  NS_ABORT_IF (!ret);
 }
 
 } //namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac-queue-item.cc ns-3.36/src/wifi/model/wifi-mac-queue-item.cc
--- ns-3.35/src/wifi/model/wifi-mac-queue-item.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac-queue-item.cc	2022-04-30 18:23:58.214735300 -0700
@@ -55,6 +55,13 @@
 {
 }
 
+Ptr<WifiMacQueueItem>
+WifiMacQueueItem::GetItem (void) const
+{
+  NS_ASSERT (IsQueued ());
+  return *m_queueIt;
+}
+
 Ptr<const Packet>
 WifiMacQueueItem::GetPacket (void) const
 {
@@ -214,13 +221,6 @@
   return m_queueAc;
 }
 
-WifiMacQueueItem::ConstIterator
-WifiMacQueueItem::GetQueueIterator (void) const
-{
-  NS_ASSERT (IsQueued ());
-  return m_queueIt;
-}
-
 void
 WifiMacQueueItem::SetInFlight (void)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mac-queue-item.h ns-3.36/src/wifi/model/wifi-mac-queue-item.h
--- ns-3.35/src/wifi/model/wifi-mac-queue-item.h	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mac-queue-item.h	2022-04-30 18:23:58.214735300 -0700
@@ -25,6 +25,7 @@
 #define WIFI_MAC_QUEUE_ITEM_H
 
 #include "ns3/nstime.h"
+#include "ns3/packet.h"
 #include "wifi-mac-header.h"
 #include "amsdu-subframe-header.h"
 #include "qos-utils.h"
@@ -33,7 +34,6 @@
 namespace ns3 {
 
 class QosBlockedDestinations;
-class Packet;
 
 /**
  * \ingroup wifi
@@ -62,6 +62,15 @@
   virtual ~WifiMacQueueItem ();
 
   /**
+   * Get a pointer to this WifiMacQueueItem object. This method is useful to convert
+   * a pointer to const WifiMacQueueItem into a pointer to non-const WifiMacQueueItem.
+   * This method can only be called if this item is stored in a wifi MAC queue.
+   *
+   * \return a pointer to this WifiMacQueueItem object
+   */
+  Ptr<WifiMacQueueItem> GetItem (void) const;
+
+  /**
    * \brief Get the packet stored in this item
    * \return the packet stored in this item.
    */
@@ -156,13 +165,6 @@
    * \return the AC of the queue this item is stored into
    */
   AcIndex GetQueueAc (void) const;
-  /**
-   * Get a const iterator pointing to the position of the MPDU in the queue. This
-   * method should not be called if the MPDU is not stored in a queue.
-   *
-   * \return an iterator pointing to the position of the MPDU in the queue
-   */
-  ConstIterator GetQueueIterator (void) const;
 
   /**
    * \brief Get the MAC protocol data unit (MPDU) corresponding to this item
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.35/src/wifi/model/wifi-mode.cc ns-3.36/src/wifi/model/wifi-mode.cc
--- ns-3.35/src/wifi/model/wifi-mode.cc	2021-10-01 13:26:48.000000000 -0700
+++ ns-3.36/src/wifi/model/wifi-mode.cc	2022-04-30 18:23:58.214735300 -0700
@@ -59,8 +59,18 @@
 bool
 WifiMode::IsAllowed (uint16_t channelWidth, uint8_t nss) const
 {
+  WifiTxVector txVector;
+  txVector.SetMode (WifiMode (m_uid));
+  txVector.SetChannelWidth (channelWidth);
+  txVector.SetNss (nss);
+  return IsAllowed (txVector);
+}
+
+bool
+WifiMode::IsAllowed (const WifiTxVector& txVector) const
+{
   WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  return item->IsModeAllowedCallback (channelWidth, nss);
+  return item->IsAllowedCallback (txVector);
 }
 
 uint64_t
@@ -72,15 +82,19 @@
 uint64_t
 WifiMode::GetPhyRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const
 {
-  WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  return item->GetPhyRateCallback (channelWidth, guardInterval, nss);
+  WifiTxVector txVector;
+  txVector.SetMode (WifiMode (m_uid));
+  txVector.SetChannelWidth (channelWidth);
+  txVector.SetGuardInterval (guardInterval);
+  txVector.SetNss (nss);
+  return GetPhyRate (txVector);
 }
 
 uint64_t
 WifiMode::GetPhyRate (const WifiTxVector& txVector, uint16_t staId) const
 {
   WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  return item->GetPhyRateFromTxVectorCallback (txVector, staId);
+  return item->GetPhyRateCallback (txVector, staId);
 }
 
 uint64_t
@@ -93,15 +107,19 @@
 WifiMode::GetDataRate (const WifiTxVector& txVector, uint16_t staId) const
 {
   WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  return item->GetDataRateFromTxVectorCallback (txVector, staId);
+  return item->GetDataRateCallback (txVector, staId);
 }
 
 uint64_t
 WifiMode::GetDataRate (uint16_t channelWidth, uint16_t guardInterval, uint8_t nss) const
 {
   NS_ASSERT (nss <= 8);
-  WifiModeFactory::WifiModeItem *item = WifiModeFactory::GetFactory ()->Get (m_uid);
-  return item->GetDataRateCallback (channelWidth, guardInterval, nss);
+  WifiTxVector txVector;
+  txVector.SetMode (WifiMode (m_uid));
+  txVector.SetChannelWidth (channelWidth);
+  txVector.SetGuardInterval (guardInterval);
+  txVector.SetNss (nss);
+  return GetDataRate (txVector);
 }
 
 WifiCodeRate
@@ -245,10 +263,8 @@
                                  CodeRateCallback codeRateCallback,
                                  ConstellationSizeCallback constellationSizeCallback,
                                  PhyRateCallback phyRateCallback,
-                                 PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
                                  DataRateCallback dataRateCallback,
-                                 DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
-                                 ModeAllowedCallback isModeAllowedCallback)
+                                 AllowedCallback isAllowedCallback)
 {
   WifiModeFactory *factory = GetFactory ();
   uint32_t uid = factory->AllocateUid (uniqueName);
@@ -274,11 +290,9 @@
   item->GetCodeRateCallback = codeRateCallback;
   item->GetConstellationSizeCallback = constellationSizeCallback;
   item->GetPhyRateCallback = phyRateCallback;
-  item->GetPhyRateFromTxVectorCallback = phyRateFromTxVectorCallback;
   item->GetDataRateCallback = dataRateCallback;
-  item->GetDataRateFromTxVectorCallback = dataRateFromTxVectorCallback;
   item->GetNonHtReferenceRateCallback = MakeNullCallback<uint64_t> ();
-  item->IsModeAllowedCallback = isModeAllowedCallback;
+  item->IsAllowedCallback = isAllowedCallback;
 
   NS_ASSERT (modClass < WIFI_MOD_CLASS_HT);
   //fill unused MCS item with a dummy value
@@ -291,14 +305,13 @@
 WifiModeFactory::CreateWifiMcs (std::string uniqueName,
                                 uint8_t mcsValue,
                                 WifiModulationClass modClass,
+                                bool isMandatory,
                                 CodeRateCallback codeRateCallback,
                                 ConstellationSizeCallback constellationSizeCallback,
                                 PhyRateCallback phyRateCallback,
-                                PhyRateFromTxVectorCallback phyRateFromTxVectorCallback,
                                 DataRateCallback dataRateCallback,
-                                DataRateFromTxVectorCallback dataRateFromTxVectorCallback,
                                 NonHtReferenceRateCallback nonHtReferenceRateCallback,
-                                ModeAllowedCallback isModeAllowedCallback)
+                                AllowedCallback isAllowedCallback)
 {
   WifiModeFactory *factory = GetFactory ();
   uint32_t uid = factory->AllocateUid (uniqueName);
@@ -309,17 +322,13 @@
   NS_ASSERT (modClass >= WIFI_MOD_CLASS_HT);
 
   item->mcsValue = mcsValue;
+  item->isMandatory = isMandatory;
   item->GetCodeRateCallback = codeRateCallback;
   item->GetConstellationSizeCallback = constellationSizeCallback;
   item->GetPhyRateCallback = phyRateCallback;
-  item->GetPhyRateFromTxVectorCallback = phyRateFromTxVectorCallback;
   item->GetDataRateCallback = dataRateCallback;
-  item->GetDataRateFromTxVectorCallback = dataRateFromTxVectorCallback;
   item->GetNonHtReferenceRateCallback = nonHtReferenceRateCallback;
-  item->IsModeAllowedCallback = isModeAllowedCallback;
-
-  //fill unused items with dummy values
-  item->isMandatory = false;
+  item->IsAllowedCallback = isAllowedCallback;
 
   return WifiMode (uid);
 }
@@ -399,12 +408,10 @@
       item->mcsValue = 0;
       item->GetCodeRateCallback = MakeNullCallback<WifiCodeRate> ();
       item->GetConstellationSizeCallback = MakeNullCallback<uint16_t> ();
-      item->GetPhyRateCallback = MakeNullCallback<uint64_t, uint16_t, uint16_t, uint8_t> ();
-      item->GetPhyRateFromTxVectorCallback = MakeNullCallback<uint64_t, const WifiTxVector&, uint16_t> ();
-      item->GetDataRateCallback = MakeNullCallback<uint64_t, uint16_t, uint16_t, uint8_t> ();
-      item->GetDataRateFromTxVectorCallback = MakeNullCallback<uint64_t, const WifiTxVector&, uint16_t> ();
+      item->GetPhyRateCallback = MakeNullCallback<uint64_t, const WifiTxVector&, uint16_t> ();
+      item->GetDataRateCallback = MakeNullCallback<uint64_t, const WifiTxVector&, uint16_t> ();
       item->GetNonHtReferenceRateCallback = MakeNullCallback<uint64_t> ();
-      item->IsModeAllowedCallback = MakeNullCallback<bool, uint16_t, uint8_t> ();
+      item->IsAllowedCallback = MakeNullCallback<bool, const WifiTxVector&> ();
       isFirstTime = false;
     }
   return &factory;
